; Modified from Nick Bensema's playfield code by 
; Randall Gordon (DarkOrk) / DarkOrk@digicron.com / UIN: 1695704
; Nick's Site: http://www.primenet.com/~nickb/atariprg.htm
; Thanks for the great code Nick
; For more info about all the instructions used in this program
; get his source code.  I just commented the parts I changed
; and added.
;
;	Description
;
;    Draws a 'palette' on the screen by setting the playfield
;    registers to be a solid line and changing the playfield's
;    color each scanline.
;    The colors were used on the Atari logo...You'll know what
;    I mean when you look at it.

	processor 6502
	include vcs.h

	org $F000

ColorOffset = $80

START
	SEI
	CLD
	LDX  #$FF
	TXS
	LDA #0
B1      STA 0,X
	DEX
	BNE B1

;Init stuff
	LDA #0	   ; Load 0 into A
	STA ColorOffset ; Store A (0) into ColorOffset
	LDA #$FF   ; Load FF (256) into A
	STA PF0	   ; Store A (FF) into PF0,PF1, & PF2
	STA PF1	   ; This makes the whole playfield a solid line.
	STA PF2	   ; Because it is never changed the whole screen is covered

MainLoop
	JSR  VB
	JSR  MoveDown
	JSR  DrawScreen
	JSR  OverScan
	JMP  MainLoop

VB ;Vertical Blanking
	LDA  #2
	STA  WSYNC  
	STA  WSYNC
	STA  WSYNC
	STA  VSYNC
	STA  WSYNC
	STA  WSYNC
	LDA  #44
	STA  TIM64T
	LDA  #0
	STA  CXCLR
	STA  WSYNC
	STA  VSYNC

	RTS  

MoveDown
	DEC ColorOffset   ; Subtract 1 from ColorOffset
	RTS

DrawScreen
	LDA INTIM
	BNE DrawScreen
	STA WSYNC
	STA VBLANK
	LDA #1
	STA CTRLPF
	LDY #191

; Now we draw to the screen by storing values in the playfield
; registers (PF0, PF1, PF2).  However I did this earlier in the
; code because I want a solid line on every scanline.  All that
; is done is changing the color of the playfield by storing the
; color value in the COLUPF register.  The color is changed by

ScanLoop
	STA WSYNC
	TYA		;Transfer Y to A
	SBC ColorOffset	;Subtract the value of YCoord from A
	STA COLUPF	;Store the value of A in COLUPF
	DEY
	BNE ScanLoop

	LDA #2
	STA WSYNC
	STA VBLANK
	RTS

OverScan
	LDX #30
KillLines
	 STA WSYNC
	 DEX
	 BNE KillLines
	RTS

	org $FFFC
	.word START
	.word START

	org $FF00

